﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDataChartPreviewRectCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();
        }          

        Rectangle rect = null;
        double originalLeft = 0;
        DoubleCollection dashArray = new DoubleCollection(new List<double>() { 2 });
        private void XamDataChart_PreviewMouseUp(object sender, MouseButtonEventArgs e)
        {
            if (rect != null)
            {
                XamDataChart chart = sender as XamDataChart;
                chart.PlotAreaBackground = rect.Fill;
                if (rect.Width > 10)
                {
                    Point p = e.GetPosition(xAxis.RootCanvas);

                    double left = Canvas.GetLeft(rect);
                    double right = Canvas.GetLeft(rect) + rect.Width;

                    double unscale = xAxis.UnscaleValue(p.X); //Based on INDEX of category values. 0 based, so divide by ItemsCount - 1.

                    double leftScale = xAxis.UnscaleValue(left) / (xAxis.ItemsCount - 1);
                    double rightScale = xAxis.UnscaleValue(right) / (xAxis.ItemsCount - 1);

                    double rectX = leftScale;
                    double rectWidth = (rightScale - leftScale);

                    chart.WindowRect = new Rect(rectX, 0, rectWidth, 1);
                }
            }

            xAxis.RootCanvas.Children.Remove(rect);
            rect = null;

        }

        private void XamDataChart_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            XamDataChart chart = sender as XamDataChart;
            Point p = e.GetPosition(xAxis.RootCanvas);

            rect = new Rectangle();
            rect.Fill = Brushes.White;
            rect.Stroke = Brushes.Black;
            rect.StrokeDashArray = dashArray;

            chart.PlotAreaBackground = Brushes.LightGray;

            Canvas.SetTop(rect, 0);
            Canvas.SetLeft(rect, p.X);

            originalLeft = p.X;

            rect.Height = xAxis.RootCanvas.ActualHeight;            
            xAxis.RootCanvas.Children.Add(rect);
        }

        private void XamDataChart_PreviewMouseMove(object sender, MouseEventArgs e)
        {
            if (rect != null && Mouse.LeftButton == MouseButtonState.Pressed)
            {
                Point p = e.GetPosition(xAxis.RootCanvas);

                double left = Canvas.GetLeft(rect);

                if(p.X < originalLeft)
                {
                    rect.Width = Math.Abs(p.X - originalLeft);
                    Canvas.SetLeft(rect, p.X);                    
                }
                else
                {
                    rect.Width = p.X - left;
                }
            }
        }
    }
}
